package net.nitus.museu.migraCoordenades;

import java.util.StringTokenizer;

/**
 * Classe que implementa la representació d'un punt amb coordenades
 * UTM 31 (ED50)
 * @author xnavarro
 *
 */
public class CoordenadaED50 {
	private double longitud;
	private double latitud;
	private double noUsat1;
	private double noUsat2;
	private boolean ring;
	
	/**
	 * Constructor a partir de doubles.
	 * @param longitud
	 * @param latitud
	 * @param noUsat1
	 * @param noUsat2
	 */
	public CoordenadaED50(double longitud, double latitud, double noUsat1, double noUsat2){
		this.longitud=longitud;
		this.latitud=latitud;
		this.noUsat1=noUsat1;
		this.noUsat2=noUsat2;
		this.ring=false;
	}
	/**
	 * Conztructor a partir de doubles, amb l'atribut ring
	 * @param longitud
	 * @param latitud
	 * @param noUsat1
	 * @param noUsat2
	 * @param ring
	 */
	public CoordenadaED50(double longitud, double latitud, double noUsat1, double noUsat2, boolean ring){
		this.longitud=longitud;
		this.latitud=latitud;
		this.noUsat1=noUsat1;
		this.noUsat2=noUsat2;
		this.ring=ring;
	}
	
	/**
	 * Implementa un constructor a partir de la cadena desada al shapeFile.
	 * @param coordenada
	 */
	public CoordenadaED50(String coordenada){
		this.ring=coordenada.indexOf("Ring")!=-1; 
		coordenada = coordenada.substring(coordenada.indexOf('(')+1);
		coordenada = coordenada.substring(0,coordenada.indexOf(')'));
		
		int comptaTokens = 0;
		String token;
		StringTokenizer st = new StringTokenizer(coordenada, ",");
		while (st.hasMoreTokens()) {
            token = st.nextToken();
            double valor = new Double(token);
            comptaTokens++;
            switch (comptaTokens) {
			case 1:
				this.longitud=valor;
				break;
			case 2:
				this.latitud=valor;
				break;
			case 3:
				this.noUsat1=valor;
				break;
			case 4:
				this.noUsat2=valor;
				break;
			default:
				break;
			}
        }
	}

	/**
	 * Sobreescriu el mètode toString
	 */
	public String toString(){
		String cadena = "(";
		cadena += "longitud: "+this.longitud+", ";
		cadena += "latitud: "+this.latitud+", ";
		cadena += "noUsat1: "+this.noUsat1+", ";
		cadena += "noUsat2: "+this.noUsat2+", ";
		cadena += "esRing: "+this.ring+", ";
		cadena += ")";
		return cadena;
	}

	// Els getters i els setters
	public double getLongitud() {
		return longitud;
	}
	public void setLongitud(double longitud) {
		this.longitud = longitud;
	}
	public double getLatitud() {
		return latitud;
	}
	public void setLatitud(double latitud) {
		this.latitud = latitud;
	}
	public double getNoUsat1() {
		return noUsat1;
	}
	public void setNoUsat1(double noUsat1) {
		this.noUsat1 = noUsat1;
	}
	public double getNoUsat2() {
		return noUsat2;
	}
	public void setNoUsat2(double noUsat2) {
		this.noUsat2 = noUsat2;
	}
	
	public boolean isRing() {
		return ring;
	}
	public void setRing(boolean ring) {
		this.ring = ring;
	}
}
