package net.nitus.museu.migraCoordenades;

import java.math.BigDecimal;
import java.util.StringTokenizer;

import net.nitus.museu.context.CoordenadaGeografica;
/**
 * Classe que implementa una coordenada geogràfica construïda
 * a partir de la cadena dels fitxers.
 * 
 * @author xnavarro
 *
 */
public class GeograficaFitxer extends CoordenadaGeografica{
	Character sentit;
	
	/**
	 * Construcor que exten CoordenadaGeografia i afegeix
	 * la funcionalitat d'interpretar els vèrtexs tal com
	 * estan guardats al fitxer.
	 * @param coordenada
	 */
	public GeograficaFitxer(String coordenada){
		//0 38 44.7E, 42 35 0.3N
		String token;
		int comptaTokens = 0;
		StringTokenizer st = new StringTokenizer(coordenada, " ");
		while (st.hasMoreTokens()) {
            token = st.nextToken();
            comptaTokens++;
            if (comptaTokens==1) graus = new Integer(token);
            else if (comptaTokens==2) minuts = new Integer(token);
            else {
            	char ultim = token.charAt(token.length()-1);
            	if (ultim=='E' || ultim=='N' || ultim=='S' || ultim=='W') {
            		token=token.substring(0,token.length()-1);
            		sentit = ultim;
            	}
            	else sentit = null;
            	segons = new BigDecimal(token);
            }
        }
        wgs84=toDecimal();
	}

	/**
	 * Sobreescriuu el metode toString
	 */
	public String toString(){
		return graus+" "+minuts+" "+segons+(sentit==null ? "" : sentit);
	}
	
	// Els getters i els setters
	public Integer getGraus() {
		return graus;
	}

	public void setGraus(Integer graus) {
		this.graus = graus;
	}

	public Integer getMinuts() {
		return minuts;
	}

	public void setMinuts(Integer minuts) {
		this.minuts = minuts;
	}

	public BigDecimal getSegons() {
		return segons;
	}

	public void setSegons(BigDecimal segons) {
		this.segons = segons;
	}

	public Character getSentit() {
		return sentit;
	}

	public void setSentit(Character sentit) {
		this.sentit = sentit;
	}
	
}
