package net.nitus.museu.migraCoordenades;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;


import net.nitus.dbcon.SQL;

/**
 * Llegeix el fitxer de jaciments i carrega els registres a la 
 * base de dades.
 * @author xnavarro
 *
 */
public class MigraJaciments {
	static String file = "Jaciments.txt";
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Connection museu = null;
		String insert = null;
		try {
			System.out.println("Carregant el driver jdbc.");
			Class.forName("org.postgresql.Driver");
			
			System.out.println("Connecant a la base de dades.");
			museu = DriverManager.getConnection("jdbc:postgresql://localhost:5432/Museu","museu","patata");
			museu.setAutoCommit(false);
			Statement stmt = museu.createStatement();
			
			System.out.println("Llegint el fitxer i guardant els registres a la taula temporal...");
			int comptalinies = 0;
			BufferedReader br = new BufferedReader (new FileReader (file));
	        String registre = br.readLine();
	        while (registre != null) {
	        	comptalinies++;
	        	if (registre.startsWith("#")) registre=br.readLine();
	        	if (!registre.equals("")){
		        	System.out.println(registre);
		        	JacimentMigracio j = new JacimentMigracio(registre);
		        	insert = j.desa();
		        	stmt.executeUpdate(insert);
	        	}
	        	registre = br.readLine();
	        }
	        
			museu.commit();
			stmt.close();
			museu.close();
			System.out.println("S'ha llegit el fitxer i s'ha guardat "+comptalinies+" jaciments.");
		}
		catch (SQLException e) {
			System.err.println(insert);
			System.err.println("ErrorSQL: "+e.getErrorCode()+"-"+e.getSQLState()+":"+e.getLocalizedMessage());
			SQL.rollbackTry(museu);
			try {
				if (museu!=null && !museu.isClosed())museu.close();
			} catch (SQLException e1) {
				System.out.println("Error tancant la connexió a la base de dades.");
				e1.printStackTrace();
			}
			System.exit(-1);
		} catch (ClassNotFoundException e) {
			System.err.println("No s'ha trobat el driver jdbc.");
			e.printStackTrace();
			System.exit(-1);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(-1);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(-1);
		}
		System.exit(0);
	}
}
