package net.nitus.museu.migraCoordenades;

import java.math.BigDecimal;
import java.util.StringTokenizer;

/**
 * Classe que modela un punt geogràfic a partir de les seves
 * coordenades 
 * @author xnavarro
 *
 */
public class PuntGeografic {
	GeograficaFitxer longitud;
	GeograficaFitxer latitud;
	BigDecimal xWGS84;
	BigDecimal yWGS84;
	
	public PuntGeografic(String coordenades){
		//0 38 44.7E, 42 35 0.3N
		String token;
		int comptaTokens = 0;
		StringTokenizer st = new StringTokenizer(coordenades, ",");
		while (st.hasMoreTokens()) {
            token = st.nextToken();
            comptaTokens++;
            if (comptaTokens==1) longitud = new GeograficaFitxer(token);
            else if (comptaTokens==2) latitud=new GeograficaFitxer(token);
        }
		
	}

	public String toString(){
		return "["+longitud.toString()+", "+latitud.toString()+"]";
	}
	
	public GeograficaFitxer getLongitud() {
		return longitud;
	}

	public void setLongitud(GeograficaFitxer longitud) {
		this.longitud = longitud;
	}

	public GeograficaFitxer getLatitud() {
		return latitud;
	}

	public void setLatitud(GeograficaFitxer latitud) {
		this.latitud = latitud;
	}
}
