package net.nitus.museu.migraCoordenades;

import java.util.ArrayList;

/**
 * Modela una capa d'un shapefile
 * @author xnavarro
 *
 */
public class Shape {
	String tipus;
	Integer nVertexs;
	Integer nParts;
	CoordenadaED50 fromBounds;
	CoordenadaED50 toBounds;
	ArrayList<CoordenadaED50> vertexs;
	
	/**
	 * Constructor a partir d'una línia del fitxer: Shape:3 (Arc)  nVertices=112, nParts=1
	 * @param shape
	 */
	public Shape(String shape) {
		this.fromBounds=null;
		this.toBounds=null;
		this.vertexs=new ArrayList<CoordenadaED50>();
		this.tipus=shape.substring(shape.indexOf(':')+1,shape.indexOf("nVertices"));
		this.nVertexs = new Integer(shape.substring(shape.indexOf("nVertices=")+10,shape.indexOf(',')));
		this.nParts = new Integer(shape.substring(shape.indexOf("nParts=")+7));
	}
	
	/**
	 * Processa les línies del shape:   Bounds:(314413.840000,4744514.750000, 0, 0)
	 * @param line
	 */
	public void liniaFromBounds(String line){
		this.fromBounds=new CoordenadaED50(line);
	}

	/**
	 * Processa les línies del shape:      to (315086.520000,4746707.860000, 0, 0)
	 * @param line
	 */
	public void liniaToBounds(String line){
		this.toBounds=new CoordenadaED50(line);
	}

	/**
	 * Afegeix un vèrtex a la llista de vèrtexs.
	 * @param coordenada
	 */
	public void addVertex(CoordenadaED50 coordenada){
		this.vertexs.add(coordenada);
	}

	/**
	 * Valida que el número de vèrtexs llegits es correspongui
	 * amb el número de vèrtexs que indica el camp.
	 */
	public void valida(){
		if (nVertexs!=vertexs.size()) System.err.println("Els vertexs de la llista no coincideix amb el nombre de vertexs.");
	}
	
	public String toString(){
		String cadena = "[";
		cadena += "tipus = "+this.tipus+" ";
		cadena += "nVertex = "+this.nVertexs+", ";
		cadena += "[nVertex == vertexs.size()] = "+(nVertexs==vertexs.size())+", ";
		cadena += "nParts = "+this.nParts+"\n";
		cadena += "fromBounds = "+this.fromBounds+"\n";
		cadena += "toBounds = "+this.toBounds+"\n";
		cadena += "]\n";
		return cadena;
	}

	// Els getters i els setters
	public String getTipus() {
		return tipus;
	}

	public void setTipus(String tipus) {
		this.tipus = tipus;
	}

	public Integer getnVertexs() {
		return nVertexs;
	}

	public void setnVertexs(Integer nVertexs) {
		this.nVertexs = nVertexs;
	}

	public Integer getnParts() {
		return nParts;
	}

	public void setnParts(Integer nParts) {
		this.nParts = nParts;
	}

	public CoordenadaED50 getFromBounds() {
		return fromBounds;
	}

	public void setFromBounds(CoordenadaED50 fromBounds) {
		this.fromBounds = fromBounds;
	}

	public CoordenadaED50 getToBounds() {
		return toBounds;
	}

	public void setToBounds(CoordenadaED50 toBounds) {
		this.toBounds = toBounds;
	}

	public ArrayList<CoordenadaED50> getVertexs() {
		return vertexs;
	}

	public void setVertexs(ArrayList<CoordenadaED50> vertexs) {
		this.vertexs = vertexs;
	}
	
}
