package net.nitus.museu.context;

import java.math.BigDecimal;

/**
 * Classe que implementa un punt del mapa en coordenades longitud/latitud
 * Tant pot servir per a un ED50 amb l'equivalència x-Longitud y-Latitud
 * com per a un WGS84 en decimal.
 * @author xnavarro
 *
 */
public class GeoCoordenadaDigital {
	private BigDecimal longitud;
	private BigDecimal latitud;
	
	/**
	 * El constructor a partir de la longitud i la latitud
	 * @param longitud
	 * @param latitud
	 */
	public GeoCoordenadaDigital(BigDecimal longitud, BigDecimal latitud){
		this.longitud=longitud;
		this.latitud=latitud;
	}
	
	/**
	 * Sobreescrivim el toString
	 */
	public String toString(){
		return "["+getLongitud()+", "+getLatitud()+"]";
	}

	// Els getters i els Setters
	public BigDecimal getLongitud() {
		return longitud;
	}

	public void setLongitud(BigDecimal longitud) {
		this.longitud = longitud;
	}

	public BigDecimal getLatitud() {
		return latitud;
	}

	public void setLatitud(BigDecimal latitud) {
		this.latitud = latitud;
	}
}
