package net.nitus.museu.context;


import java.util.StringTokenizer;
import net.nitus.widgets.StringsTools;
/**
 * Classe que implementa les imatges d'un objecte 
 * @author xnavarro
 *
 */
public class Imatge {
	private int jaciment;
	private int periode;
	private int objecte;
	private int n;
	private String url;
	private Integer xImatge;
	private Integer yImatge;
	private String comentari;
	
	/**
	 * Constructor null;
	 */
	public Imatge(){
		this.jaciment=-1;
		this.periode=-1;
		this.objecte=-1;
		this.n=-1;
		this.url=null;
		this.comentari=null;
	}
	
	/**
	 * Constructor a partir d'una línia del fitxer font.
	 * @param registre Una fila del fitxer amb les dades del període.
	 */
	public Imatge(String registre){
		int comptaTokens=0;
		String token;
		StringTokenizer st = new StringTokenizer(registre, ";");
		while (st.hasMoreTokens()) {
			comptaTokens++;
            token = st.nextToken();
            if (comptaTokens==1) setJaciment(token);
            else if (comptaTokens==2) setPeriode(token);
            else if (comptaTokens==3) setObjecte(token);
            else if (comptaTokens==4) setN(token);
            else if (comptaTokens==5) setUrl(token);
            else if (comptaTokens==6) setxImatge(token);
            else if (comptaTokens==7) setyImatge(token);
            //else if (comptaTokens==8) setxImatgeMini(token);
            //else if (comptaTokens==9) setyImatgeMini(token);
            else if (comptaTokens==10) setComentari(token);
        }
	}
	
	/**
	 * Sobres-escriu el mètode toString
	 */
	public String toString(){
		String classe = "[\n";
		classe+= "Jaciment: "+getJaciment()+", ";
		classe+= "Periode: "+getPeriode()+", ";
		classe+= "Objecte: "+getObjecte()+", ";
		classe+= "N: "+getN()+", ";
		classe+= "Url: "+getUrl()+", ";
		classe+= "Comentari: "+getComentari();
		classe+= "]";
		return classe;
	}

	/**
	 * Retorna una cadena sql per afegir el registre a la taula d'imatges
	 * @return
	 */
	public String afegeix(){
		String vComentari= "null";
		if (getComentari()!=null && !getComentari().equals("")) vComentari = "'"+StringsTools.dq(getComentari())+"'";
		
		String insert = "INSERT INTO Jaciments.Imatges("+
            					"jaciment, periode, objecte, n, " +
            					"url, xImatge, yImatge, comentaris) "+
            			"VALUES ("+getJaciment()+", "+getPeriode()+", "+getObjecte()+", "+getN()+", '"+StringsTools.dq(getUrl())+"', " +
            					+getxImatge()+", "+getyImatge()+", "+vComentari+")";
		return insert;
	}

	// Els getters i els setters
	public int getPeriode() {
		return periode;
	}

	public void setPeriode(int periode) {
		this.periode = periode;
	}
	public void setPeriode(String periode) {
		this.periode = new Integer(periode).intValue();
	}

	public int getJaciment() {
		return jaciment;
	}

	public void setJaciment(int jaciment) {
		this.jaciment = jaciment;
	}
	public void setJaciment(String jaciment) {
		this.jaciment = new Integer(jaciment).intValue();
	}

	public int getObjecte() {
		return objecte;
	}

	public void setObjecte(int objecte) {
		this.objecte = objecte;
	}
	public void setObjecte(String objecte) {
		this.objecte = new Integer(objecte).intValue();
	}

	public int getN() {
		return n;
	}

	public void setN(int n) {
		this.n = n;
	}
	public void setN(String n) {
		this.n = new Integer(n).intValue();
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getComentari() {
		return comentari;
	}

	public void setComentari(String comentari) {
		this.comentari = comentari;
	}

	public Integer getxImatge() {
		return xImatge;
	}

	public void setxImatge(int xImatge) {
		this.xImatge = xImatge;
	}
	public void setxImatge(String xImatge) {
		this.xImatge=new Integer(xImatge);
	}
	
	public Integer getyImatge() {
		return yImatge;
	}

	public void setyImatge(int yImatge) {
		this.yImatge = yImatge;
	}

	public void setyImatge(String yImatge) {
		this.yImatge=new Integer(yImatge);
	}


}
