package net.nitus.museu.context;


import java.util.StringTokenizer;
import net.nitus.widgets.StringsTools;
/**
 * Classe que implementa un Objecte d'un Període Històric.
 * @author xnavarro
 *
 */
public class Objecte {
	private int jaciment;
	private int periode;
	private int n;
	private String descripcio;
	private String comentari;
	
	/**
	 * Constructor null;
	 */
	public Objecte(){
		this.jaciment=-1;
		this.periode=-1;
		this.n=-1;
		this.descripcio=null;
		this.comentari=null;
	}
	
	/**
	 * Constructor a partir d'una línia del fitxer font.
	 * @param registre Una fila del fitxer amb les dades del període.
	 */
	public Objecte(String registre){
		int comptaTokens=0;
		String token;
		StringTokenizer st = new StringTokenizer(registre, ";");
		while (st.hasMoreTokens()) {
			comptaTokens++;
            token = st.nextToken();
            if (comptaTokens==1) setJaciment(token);
            else if (comptaTokens==2) setPeriode(token);
            else if (comptaTokens==3) setN(token);
            else if (comptaTokens==4) setDescripcio(token);
            else if (comptaTokens==5) setComentari(token);
        }
	}
	
	/**
	 * Sobres-escriu el mètode toString
	 */
	public String toString(){
		String classe = "[\n";
		classe+= "Jaciment: "+getJaciment()+", ";
		classe+= "Periode: "+getPeriode()+", ";
		classe+= "N: "+getN()+", ";
		classe+= "Descripcio: "+getDescripcio()+", ";
		classe+= "Comentari: "+getComentari();
		classe+= "]";
		return classe;
	}

	/**
	 * Retorna una cadena sql per afegir el registre a la taula d'Objectes
	 * @return
	 */
	public String afegeix(){
		String vComentari= "null";
		if (getComentari()!=null && !getComentari().equals("")) vComentari = "'"+StringsTools.dq(getComentari())+"'";
		String vDescripcio= "null";
		if (getDescripcio()!=null && !getDescripcio().equals("")) vDescripcio = "'"+StringsTools.dq(getDescripcio())+"'";
		
		String insert = "INSERT INTO Jaciments.Objectes("+
            					"jaciment, periode, n, Descripcio, comentaris) "+
            			"VALUES ("+getJaciment()+", "+getPeriode()+", "+getN()+", "+vDescripcio+", "+vComentari+")";
		return insert;
	}

	// Els getters i els setters
	public int getPeriode() {
		return periode;
	}

	public void setPeriode(int periode) {
		this.periode = periode;
	}
	public void setPeriode(String periode) {
		this.periode = new Integer(periode).intValue();
	}

	public int getJaciment() {
		return jaciment;
	}

	public void setJaciment(int jaciment) {
		this.jaciment = jaciment;
	}
	public void setJaciment(String jaciment) {
		this.jaciment = new Integer(jaciment).intValue();
	}

	public int getN() {
		return n;
	}

	public void setN(int n) {
		this.n = n;
	}
	public void setN(String n) {
		this.n = new Integer(n).intValue();
	}

	public String getDescripcio() {
		return descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	public String getComentari() {
		return comentari;
	}

	public void setComentari(String comentari) {
		this.comentari = comentari;
	}

	
	
}
