package net.nitus.museu.context;


import java.util.StringTokenizer;
import net.nitus.widgets.StringsTools;
/**
 * Classe que implementa un Període Històric 
 * @author xnavarro
 *
 */
public class PeriodeHistoric {
	private int id;
	private String nom;
	private String uNom;
	private String comentari;
	
	/**
	 * Constructor null;
	 */
	public PeriodeHistoric(){
		this.id=-1;
		this.nom=null;
		this.uNom=null;
		this.comentari=null;
	}
	
	/**
	 * Constructor a partir d'una línia del fitxer font.
	 * @param registre Una fila del fitxer amb les dades del període.
	 */
	public PeriodeHistoric(String registre){
		int comptaTokens=0;
		String token;
		StringTokenizer st = new StringTokenizer(registre, ";");
		while (st.hasMoreTokens()) {
			comptaTokens++;
            token = st.nextToken();
            if (comptaTokens==1) setId(token);
            else if (comptaTokens==2) setNom(token);
        }
	}
	
	/**
	 * Sobres-escriu el mètode toString
	 */
	public String toString(){
		String classe = "[\n";
		classe+= "Id: "+getId()+", ";
		classe+= "nom: "+getNom()+", ";
		classe+= "unom "+getuNom()+", ";
		classe+= "Comentari: "+getComentari();
		classe+= "]";
		return classe;
	}

	/**
	 * Retorna una cadena sql per afegir el registre a la taula de períodes històrics
	 * @return
	 */
	public String afegeix(){
		String vComentari;
		if (getComentari()!=null && !getComentari().equals("")) vComentari = "'"+StringsTools.dq(getComentari())+"'";
		else vComentari = "null";
		String insert = "INSERT INTO Jaciments.Periodes("+
            					"id, nom, unom, comentaris) "+
            			"VALUES ("+getId()+", '"+StringsTools.dq(getNom())+"', '"+StringsTools.dq(getuNom())+"', "+vComentari+")";
		return insert;
	}

	// Els getters i els setters
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public void setId(String id){
		this.id=new Integer(id).intValue();
	}
	
	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
		this.uNom = StringsTools.U(nom);
	}

	public String getuNom() {
		return uNom;
	}

	public String getComentari() {
		return comentari;
	}

	public void setComentari(String comentari) {
		this.comentari = comentari;
	}
	
}
