package net.nitus.museu.context;


import java.util.StringTokenizer;
import net.nitus.widgets.StringsTools;
/**
 * Classe que implementa un Període d'un Jaciment 
 * @author xnavarro
 *
 */
public class PeriodeJaciment {
	private int periode;
	private int jaciment;
	private String dates;
	private String descripcio;
	private String altres;
	private String comentari;
	
	/**
	 * Constructor null;
	 */
	public PeriodeJaciment(){
		this.periode=-1;
		this.jaciment=-1;
		this.dates=null;
		this.descripcio=null;
		this.altres=null;
		this.comentari=null;
	}
	
	/**
	 * Constructor a partir d'una línia del fitxer font.
	 * @param registre Una fila del fitxer amb les dades del període.
	 */
	public PeriodeJaciment(String registre){
		int comptaTokens=0;
		String token;
		StringTokenizer st = new StringTokenizer(registre, ";");
		while (st.hasMoreTokens()) {
			comptaTokens++;
            token = st.nextToken();
            if (comptaTokens==1) setPeriode(token);
            else if (comptaTokens==3) setJaciment(token);
            else if (comptaTokens==5) setDates(token);
            else if (comptaTokens==6) setDescripcio(token);
            else if (comptaTokens==7) setAltres(token);
            else if (comptaTokens==8) setComentari(token);
        }
	}
	
	/**
	 * Sobres-escriu el mètode toString
	 */
	public String toString(){
		String classe = "[\n";
		classe+= "Periode: "+getPeriode()+", ";
		classe+= "Jaciment: "+getJaciment()+", ";
		classe+= "Dates: "+getDates()+", ";
		classe+= "Descripcio: "+getDescripcio()+", ";
		classe+= "Altres: "+getAltres()+", ";
		classe+= "Comentari: "+getComentari();
		classe+= "]";
		return classe;
	}

	/**
	 * Retorna una cadena sql per afegir el registre a la taula de períodes-jaciments
	 * @return
	 */
	public String afegeix(){
		String vComentari= "null";
		if (getComentari()!=null && !getComentari().equals("")) vComentari = "'"+StringsTools.dq(getComentari())+"'";
		String vAltres= "null";
		if (getAltres()!=null && !getAltres().equals("")) vAltres = "'"+StringsTools.dq(getAltres())+"'";
		String vDescripcio= "null";
		if (getDescripcio()!=null && !getDescripcio().equals("")) vDescripcio = "'"+StringsTools.dq(getDescripcio())+"'";
		
		String insert = "INSERT INTO Jaciments.Periodes_Jaciments("+
            					"periode, jaciment, dates, Descripcio, altres, comentaris) "+
            			"VALUES ("+getPeriode()+", "+getJaciment()+", '"+StringsTools.dq(getDates())+"', "+vDescripcio+", "+vAltres+", "+vComentari+")";
		return insert;
	}

	// Els getters i els setters
	public int getPeriode() {
		return periode;
	}

	public void setPeriode(int periode) {
		this.periode = periode;
	}
	public void setPeriode(String periode) {
		this.periode = new Integer(periode).intValue();
	}

	public int getJaciment() {
		return jaciment;
	}

	public void setJaciment(int jaciment) {
		this.jaciment = jaciment;
	}
	public void setJaciment(String jaciment) {
		this.jaciment = new Integer(jaciment).intValue();
	}

	public String getDates() {
		return dates;
	}

	public void setDates(String dates) {
		this.dates = dates;
	}

	public String getDescripcio() {
		return descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	public String getAltres() {
		return altres;
	}

	public void setAltres(String altres) {
		this.altres = altres;
	}

	public String getComentari() {
		return comentari;
	}

	public void setComentari(String comentari) {
		this.comentari = comentari;
	}

	
	
}
