package net.nitus.museu;

import java.sql.Connection;
import java.sql.SQLException;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

/**
 * Classe que implementa un pool de connexions
 * @author xnavarro
 *
 */
public class ConnexioDataSource {
	InitialContext ctx;
	DataSource ds;
	
	/**
	 * El constructor
	 * @param pool Cadena amb el pool de connexions
	 * @throws NamingException
	 * @throws Exception
	 */
	public ConnexioDataSource(String pool) throws NamingException, Exception{
    	ctx = new InitialContext();
    	if ( ctx == null ) throw new Exception("No s'ha pogut trobar el context.");
    	ds = (DataSource) ctx.lookup( pool );
    	if ( ds == null ) throw new Exception("No s'ha pogut trobar el DataSource.");
	}
	
	/**
	 * Mètode per utilitzar una connexió a la base
	 * de dades del pool.
	 * @return La connexio
	 * @throws SQLException
	 */
	public Connection getConnexio() throws SQLException{
		return ds.getConnection();
	}
}
